/*******************************************************************************
*
*      "cs46xxpm-22.c" --  Cirrus Logic-Crystal CS46XX linux audio driver.
*
*      Copyright (C) 2000,2001  Cirrus Logic Corp.  
*            -- tom woller (twoller@crystal.cirrus.com) or
*               (pcaudio@crystal.cirrus.com).
*
*      This program is free software; you can redistribute it and/or modify
*      it under the terms of the GNU General Public License as published by
*      the Free Software Foundation; either version 2 of the License, or
*      (at your option) any later version.
*
*      This program is distributed in the hope that it will be useful,
*      but WITHOUT ANY WARRANTY; without even the implied warranty of
*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*      GNU General Public License for more details.
*
*      You should have received a copy of the GNU General Public License
*      along with this program; if not, write to the Free Software
*      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* 12/22/00 trw - new file. 
*
*******************************************************************************/

int cs46xx_suspend(struct cs_card *s);
int cs46xx_resume(struct cs_card *s);

int cs46xx_apm_callback(apm_event_t ae) 
{
	struct cs_card *s=NULL;
	struct list_head *entry;

	CS_DBGOUT(CS_PM | CS_FUNCTION, 2, printk(KERN_INFO 
		"cs46xx: cs46xx_apm_callback(): apm_event=0x%x\n",ae));

	list_for_each(entry, &cs46xx_devs)
	{
		s = list_entry(entry, struct cs_card, list);
		if (entry == &cs46xx_devs)
			return 0;
		if (!s) {
			CS_DBGOUT(CS_PM | CS_ERROR, 2, printk(KERN_INFO
				"cs46xx: cs46xx_apm_callback(): Error - unable to find audio card struct\n"));
			return -ENODEV;
		}
		switch(ae) {

			case APM_SYS_SUSPEND: 
			case APM_CRITICAL_SUSPEND: 
			case APM_USER_SUSPEND: 
				cs46xx_suspend(s);
				break;
			case APM_NORMAL_RESUME: 
			case APM_CRITICAL_RESUME: 
			case APM_STANDBY_RESUME: 
				cs46xx_resume(s);
				break;
			case APM_POWER_STATUS_CHANGE:
				CS_DBGOUT(CS_PM, 2, printk(KERN_INFO
					"cs46xx: cs46xx_apm_callback(): APM_POWER_STATUS_CHANGE \n"));
				break;
			default: 
				CS_DBGOUT(CS_PM, 2, printk(KERN_INFO
					"cs46xx: cs46xx_apm_callback(): unknown apm_event (0x%x)\n",ae));
				break;
		}
	}
	return 0;
}

static void cs46xx_suspend_tbl(struct pci_dev *pcidev)
{
	struct cs_card *s = PCI_GET_DRIVER_DATA(pcidev);
	cs46xx_suspend(s);
	return;
}

static void cs46xx_resume_tbl(struct pci_dev *pcidev)
{
	struct cs_card *s = PCI_GET_DRIVER_DATA(pcidev);
	cs46xx_resume(s);
	return;
}

