/*******************************************************************************
*
*      "cs46xxpm-24.c" --  Cirrus Logic-Crystal CS46XX linux audio driver.
*
*      Copyright (C) 2000,2001  Cirrus Logic Corp.  
*            -- tom woller (twoller@crystal.cirrus.com) or
*               (pcaudio@crystal.cirrus.com).
*
*      This program is free software; you can redistribute it and/or modify
*      it under the terms of the GNU General Public License as published by
*      the Free Software Foundation; either version 2 of the License, or
*      (at your option) any later version.
*
*      This program is distributed in the hope that it will be useful,
*      but WITHOUT ANY WARRANTY; without even the implied warranty of
*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*      GNU General Public License for more details.
*
*      You should have received a copy of the GNU General Public License
*      along with this program; if not, write to the Free Software
*      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* 12/22/00 trw - new file. 
*
*******************************************************************************/

int cs46xx_pm_callback(struct pm_dev *dev, pm_request_t rqst, void *data)
{
	struct cs_card *card;

	CS_DBGOUT(CS_PM, 2, printk(KERN_INFO 
		"cs46xx: cs46xx_pm_callback dev=0x%x rqst=0x%x card=%d\n",
			(unsigned)dev,(unsigned)rqst,(unsigned)data));
	card = (struct cs_card *) dev->data;
	if (card) {
		switch(rqst) {
			case PM_SUSPEND:
				CS_DBGOUT(CS_PM, 2, printk(KERN_INFO
					"cs46xx: PM suspend request\n"));
				if(cs46xx_suspend(card))
				{
				    CS_DBGOUT(CS_ERROR, 2, printk(KERN_INFO
					"cs46xx: PM suspend request refused\n"));
					return 1; 
				}
				break;
			case PM_RESUME:
				CS_DBGOUT(CS_PM, 2, printk(KERN_INFO
					"cs46xx: PM resume request\n"));
				if(cs46xx_resume(card))
				{
				    CS_DBGOUT(CS_ERROR, 2, printk(KERN_INFO
					"cs46xx: PM resume request refused\n"));
					return 1;
				}
				break;
		}
	}

	return 0;
}

static void cs46xx_suspend_tbl(struct pci_dev *pcidev)
{
	struct cs_card *s = PCI_GET_DRIVER_DATA(pcidev);
	CS_DBGOUT(CS_PM | CS_FUNCTION, 2, 
		printk(KERN_INFO "cs46xx: cs46xx_suspend_tbl request\n"));
	cs46xx_suspend(s);
	return;
}

static void cs46xx_resume_tbl(struct pci_dev *pcidev)
{
	struct cs_card *s = PCI_GET_DRIVER_DATA(pcidev);
	CS_DBGOUT(CS_PM | CS_FUNCTION, 2, 
		printk(KERN_INFO "cs46xx: cs46xx_resume_tbl request\n"));
	cs46xx_resume(s);
	return;
}

